package task2;

import task1.AbstractRoadVehicle;
import test.FerryApplication;

public class TestTask2 {
    public static void test2() {
        SmallFerry smallFerry = new SmallFerry();
        BigFerry bigFerry = new BigFerry();
        for (int i = 0; i < 5; i++) {
            smallFerry.push(FerryApplication.roadVehicles[i]);
            bigFerry.push(FerryApplication.roadVehicles[i]);
        }

        StringBuilder smallFerryResult = new StringBuilder();
        StringBuilder bigFerryResult = new StringBuilder();
        for (int i = 0; i < 5; i++) {
            AbstractRoadVehicle smallFerryVehicle = smallFerry.pop();
            AbstractRoadVehicle bigFerryVehicle = bigFerry.pop();

            if (smallFerryVehicle != null) {
                smallFerryResult.append(smallFerryVehicle.getVehicleType()).append(" : ");
                smallFerryResult.append(smallFerryVehicle.getPlateNumber()).append(" ; ");
            }


            bigFerryResult.append(bigFerryVehicle.getVehicleType()).append(" : ");
            bigFerryResult.append(bigFerryVehicle.getPlateNumber()).append(" ; ");
        }

        String actualSmallFerry = smallFerryResult.toString();
        String expectedSmallFerry = "Truck : PH-111-TRK ; Car : BV-222-CAR ; Motorcycle : B-111-MOT ; Car : B-111-CAR ; ";
        if (actualSmallFerry.equals(expectedSmallFerry)) {
            System.out.println("TASK2.1 : COMPLETED");
            FerryApplication.points += 2;
        } else {
            System.out.println("TASK2.1 : FAIL");
            System.out.println("EXPECTED: " + expectedSmallFerry);
            System.out.println("ACTUAL  : " + actualSmallFerry);
        }
        FerryApplication.printSeparator();
        String actualBigFerry = bigFerryResult.toString();
        String expectedBigFerry = "Car : B-111-CAR ; Motorcycle : B-111-MOT ; Car : BV-222-CAR ; Truck : PH-111-TRK ; Truck : B-222-TRK ; ";
        if (actualBigFerry.equals(expectedBigFerry)) {
            System.out.println("TASK2.2 : COMPLETED");
            FerryApplication.points += 2;
        } else {
            System.out.println("TASK2.2 : FAIL");
            System.out.println("EXPECTED: " + expectedBigFerry);
            System.out.println("ACTUAL  : " + actualBigFerry);
        }
        FerryApplication.printSeparator();
    }
}
